unit cm_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ColMemo;

type
  TForm1 = class(TForm)
    grbxOptions: TGroupBox;
    cbxType: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Notebook1: TNotebook;
    eBegin: TEdit;
    eEnd: TEdit;
    mKeywords: TMemo;
    cbxCase: TCheckBox;
    Label5: TLabel;
    cbxColor: TComboBox;
    cbxBrush: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    Bevel1: TBevel;
    Label6: TLabel;
    btnApply: TButton;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox1: TGroupBox;
    rbMaybeFunny: TRadioButton;
    rbFunny: TRadioButton;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    ColorMemo1: TColorMemo;
    procedure cbxTypeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure DrwLine(Sender: TObject; const CMLine: string;
      var A: array of TKeyDescr);
    procedure eExit(Sender: TObject);
    procedure rbClick(Sender: TObject);
    procedure cbxBrushChange(Sender: TObject);
    procedure cbxColorChange(Sender: TObject);
  private
    { Private declarations }
    procedure AddColor( const Str:string);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.cbxTypeChange(Sender: TObject);
begin
     Case cbxType.ItemIndex of
          0: begin
               ColorMemo1.KeyDrawingType:=dtBeginEnd;
               ColorMemo1.KeyColor:=clBlue;
               cbxColor.ItemIndex:=cbxColor.Items.IndexOf('clBlue');
             end;
          1: begin
               ColorMemo1.KeyDrawingType:=dtKeyShow;
               ColorMemo1.KeyColor:=clRed;
               cbxColor.ItemIndex:=cbxColor.Items.IndexOf('clRed');
             end;
          2: begin
               ColorMemo1.KeyDrawingType:=dtEventDraw;
               ColorMemo1.KeyColor:=clAqua;
               cbxColor.ItemIndex:=cbxColor.Items.IndexOf('clAqua');
             end; 
     end;
     Notebook1.ActivePage:=cbxType.Text;
     ColorMemo1.Refresh;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     GetColorValues(AddColor);
     cbxType.ItemIndex:=0;
     cbxColor.ItemIndex:=cbxColor.Items.IndexOf('clBlue');
     cbxBrush.ItemIndex:=cbxBrush.Items.IndexOf('clWindow');
     NoteBook1.PageIndex:=0;
end;

procedure TForm1.AddColor( const Str:string);
begin
     cbxBrush.Items.Add(Str);
     cbxColor.Items.Add(Str);
end;

procedure TForm1.btnApplyClick(Sender: TObject);
begin
     ColorMemo1.KeyCase:=cbxCase.Checked;
     ColorMemo1.Keywords:=mKeywords.Lines;
     ColorMemo1.Refresh;
end;

procedure TForm1.DrwLine(Sender: TObject; const CMLine: string;
  var A: array of TKeyDescr);
var
   i, ii: integer;
begin
     if rbMaybeFunny.Checked then begin
        if (Pos(';', CMLine)<>0) 
           and (Length(CMLine) mod 2 =0) then 
        begin ;
           A[0].Left:=1;
           A[0].Right:=Length(CMLine);
        end;
     end else
     if rbFunny.Checked then begin
        ii:=0;
        for i:=1 to Length(CMLine) do begin
          if (i mod 2 = 0) then begin
             A[ii].Left:=i;
             A[ii].Right:=i;
             Inc(ii);
          end;
        end;
     end;
end;

procedure TForm1.eExit(Sender: TObject);
begin
     ColorMemo1.KeyBeginChar:=eBegin.Text[1];
     ColorMemo1.KeyEndChar  :=eEnd.Text[1];
     ColorMemo1.Refresh;
end;

procedure TForm1.rbClick(Sender: TObject);
begin
     ColorMemo1.Refresh;
end;

procedure TForm1.cbxBrushChange(Sender: TObject);
var
   cl:LongInt;
begin
     IdentToColor( cbxBrush.Text, cl);
     ColorMemo1.KeyBrushColor:=cl;
     ColorMemo1.Refresh;
end;

procedure TForm1.cbxColorChange(Sender: TObject);
var
   cl:LongInt;
begin
     IdentToColor( cbxColor.Text, cl);
     ColorMemo1.KeyColor:=cl;
     ColorMemo1.Refresh;
end;

end.
 